using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace OldTextures
{
    public class OldTextures
    {

        public static void Main()
        { 

          CategoryBuilder.Create("Old Entities", "", ModAPI.LoadSprite("CategoryIcons/entities.png"));
          CategoryBuilder.Create("Old Firearms", "", ModAPI.LoadSprite("CategoryIcons/firearms.png"));
          CategoryBuilder.Create("Old Explosives", "", ModAPI.LoadSprite("CategoryIcons/explosives.png"));
          CategoryBuilder.Create("Old Vehicles", "", ModAPI.LoadSprite("CategoryIcons/vehicles.png"));
          CategoryBuilder.Create("Old Machinery", "", ModAPI.LoadSprite("CategoryIcons/machinery.png"));
          CategoryBuilder.Create("Old Melee", "", ModAPI.LoadSprite("CategoryIcons/melee.png"));
          CategoryBuilder.Create("Old Misc.", "", ModAPI.LoadSprite("CategoryIcons/misc.png"));

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("General Purpose Bomb"),
                    NameOverride = "General Purpose Bomb -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Explosives"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/GeneralPurposeBomb.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/GeneralPurposeBomb.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Dynamite"),
                    NameOverride = "Dynamite -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Explosives"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Dynamite.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Dynamite.png");
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
		   OriginalItem = ModAPI.FindSpawnable("Truck"),
		   NameOverride = "Truck -Old",
		   NameToOrderByOverride = "!",
		   DescriptionOverride = "",
		   CategoryOverride = ModAPI.FindCategory("Old Vehicles"),
		   ThumbnailOverride = ModAPI.LoadSprite("Icons/Truck.png"),
		   AfterSpawn = (Instance) =>
		   {

			Instance.transform.Find("Connector").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TruckConnector.png");
			Instance.transform.Find("Door").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TruckDoor.png");
			Instance.transform.Find("Container").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TruckContainer.png");
			Instance.transform.Find("Head").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TruckCab.png");
			Instance.transform.Find("Mirrors").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TruckMirror.png");
			Instance.transform.Find("Bumper").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TruckBumper.png");
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Human -Old",
                    NameToOrderByOverride = "Z",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory("Old Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Human.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Textures/HumanBoby.png");
                        var flesh = ModAPI.LoadTexture("Textures/HumanFlesh.png");
                        var bone = ModAPI.LoadTexture("Textures/HumanSkeleton.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "Android -Old",
                    NameToOrderByOverride = "Z",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory("Old Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Android.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Textures/AndroidBody.png");
                        var flesh = ModAPI.LoadTexture("Textures/AndroidFlesh.png");
                        var bone = ModAPI.LoadTexture("Textures/AndroidSkeleton.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Mini Thruster"),
                    NameOverride = "Mini Thruster -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Machinery"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/MiniThruster.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/MiniThruster.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Thruster"),
                    NameOverride = "Thruster -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Machinery"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Thruster.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Thruster.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Thrusterbed"),
                    NameOverride = "Thrusterbed -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Machinery"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Thrusterbed.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Thrusterbed.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Industrial Generator"),
                    NameOverride = "Industrial Generator -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Machinery"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/IndustrialGenerator.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/IndustrialGeneratorCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/IndustrialGenerator.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Generator"),
                    NameOverride = "Generator -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Machinery"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Generator.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/GeneratorCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Generator.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Shotgun"),
                    NameOverride = "Shotgun -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Shotgun.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/ShotgunCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Shotgun.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Vector"),
                    NameOverride = "Vector -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Vector.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/VectorCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Vector.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Submachine Gun"),
                    NameOverride = "Submachine Gun -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/SubmachineGun.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/SubmachineGunCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/SubmachineGun.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"),
                    NameOverride = "Sniper Rifle -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/SniperRifle.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/SniperRifleCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/SniperRifle.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("1000kg Weight"),
                    NameOverride = "1000kg Weight -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/1Ton.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/1TonCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/1Ton1.png"),
                            ModAPI.LoadSprite("Textures/1Ton2.png"),
                            ModAPI.LoadSprite("Textures/1Ton3.png"),
                        };
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "Pistol -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Pistol.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/PistolCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Pistol.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Rocket Launcher"),
                    NameOverride = "Rocket Launcher -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/RocketLauncher.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/RocketLauncherCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/RocketLauncher.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
                    NameOverride = "Assault Rifle -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/AssaultRifle.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/AssaultRifleCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/AssaultRifle.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("AK-47"),
                    NameOverride = "AK-47 -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/AK47.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/AK47Col.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/AK47.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Flamethrower"),
                    NameOverride = "Flamethrower -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Flamethrower.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/FlamethrowerCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Flamethrower.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Revolver"),
                    NameOverride = "Revolver -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Revolver.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/RevolverCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Revolver.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Rod -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Rod.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Rod.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Plank"),
                    NameOverride = "Plank -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Plank.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Plank.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("PPSH"),
                    NameOverride = "PPSH -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/PPSH.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/PPSHCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/PPSH.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Desert Eagle"),
                    NameOverride = "Desert Eagle -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/DesertEagle.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/DesertEagleCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/DesertEagle1.png"),
                            ModAPI.LoadSprite("Textures/DesertEagle2.png"),
                        };
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "M1 Garand -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/M1Garand.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/M1GarandCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/M1Garand.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Sword"),
                    NameOverride = "Sword -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Sword.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/SwordCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Sword.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Wrench"),
                    NameOverride = "Wrench -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Wrench.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/WrenchCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Wrench.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Wooden Chair"),
                    NameOverride = "Wooden Chair -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/WoodenChair.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/WoodenChair.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Wooden Table"),
                    NameOverride = "Wooden Table -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/WoodenTable.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/WoodenTable.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Plastic Barrel"),
                    NameOverride = "Plastic Barrel -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/PlasticBarrel.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/PlasticBarrel.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Wooden Pole"),
                    NameOverride = "Wooden Pole -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/WoodenPole.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/WoodenPoleCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/WoodenPole.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Bus Chair"),
                    NameOverride = "Bus Chair -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/BusChair.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/BusChairCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/BusChair.png"),
                        };
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Wooden Pillar"),
                    NameOverride = "Wooden Pillar -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/WoodenPillar.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/WoodenPillar.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Hammer"),
                    NameOverride = "Hammer -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Hammer.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/HammerCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Hammer.png");
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Metal");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Knife"),
                    NameOverride = "Knife -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Knife.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Knife.png");
                    }
                }
            );

			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Baseball Bat"),
                    NameOverride = "Baseball Bat -Old",
                    NameToOrderByOverride = "Z",
                    CategoryOverride = ModAPI.FindCategory("Old Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/BaseballBat.png"),
                    AfterSpawn = (Instance) =>
				    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/BaseballBatCol.png", 10);	

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BaseballBat.png");
                    }
                }
            );
        }
    }
}